package com.cool.hot100.linkedlist;

import org.junit.Test;


/**
 * @Author Cool
 * @Date 23:30 2024/8/23
 * DayNumber 2
 * Hard 3
 **/
public class Num25 {

    public ListNode reverseKGroup(ListNode head, int k) {
        ListNode hair=new ListNode(0);
        hair.next=head;
        ListNode pre = hair;
        while (head != null) {
            ListNode tail=pre;
            for (int i = 0; i < k; i++) {
                tail = tail.next;
                if (tail == null) {
                    return hair.next;
                }
            }
            ListNode next=tail.next;
            ListNode[] reverse = reverse(head,tail);
            head=reverse[0];
            tail=reverse[1];
            pre.next=head;
            tail.next=next;
            head=next;
            pre=tail;

        }
        return hair.next;

    }

    private ListNode[] reverse(ListNode head,ListNode next) {
        ListNode node = head;
        ListNode pre = null;
        ListNode nxt=next.next;
        while (node != nxt) {
            ListNode net = node.next;
            node.next = pre;
            pre = node;
            node = net;
        }
        return new ListNode[]{next,head};
    }

    @Test
    public void test() {
        ListNode node1 = new ListNode(7);
        ListNode node2 = new ListNode(6, node1);
        ListNode node3 = new ListNode(5, node2);
        ListNode node4 = new ListNode(4, node3);
        ListNode node5 = new ListNode(3, node4);
        ListNode node6 = new ListNode(2, node5);
        ListNode node7 = new ListNode(1, node6);
        reverseKGroup(node7, 2);
    }
}
